podTemplate(
    name: 'ecoleta',
    namespace: 'devops',
    label: 'ecoleta', 
    containers: [
        containerTemplate(args: 'cat', command: '/bin/sh -c', image: 'docker', livenessProbe: containerLivenessProbe(execArgs: '', failureThreshold: 0, initialDelaySeconds: 0, periodSeconds: 0, successThreshold: 0, timeoutSeconds: 0), name: 'docker-container', resourceLimitCpu: '', resourceLimitMemory: '', resourceRequestCpu: '', resourceRequestMemory: '', ttyEnabled: true, workingDir: '/home/jenkins/agent'),
        containerTemplate(args: 'cat', command: '/bin/sh -c', image: 'lachlanevenson/k8s-helm:v2.11.0', name: 'helm-container', ttyEnabled: true,)
    ],
    volumes: [
      hostPathVolume(mountPath: '/var/run/docker.sock', hostPath: '/var/run/docker.sock')
    ]
)
{
    //Start Pipeline
    node('ecoleta') {       
        def REPOS
        def IMAGE_VERSION
        def IMAGE_POSFIX = ""
        def KUBE_NAMESPACE
        def IMAGE_NAME = "frontend-ecoleta"
        def ENVIRONMENT        
        def GIT_REPOS_URL = "git@gitlab.com:nlw1/boosterproject/web.git"
        def GIT_BRANCH
        def HELM_DEPLOY_NAME
        def HELM_CHART_NAME = "ecoleta/frontend-ecoleta"
        def CHARTMUSEUM_URL = "http://helm-chartmuseum.devops.svc.cluster.local:8080"
        def REPO_DOCKER_LOCAL = "localhost:5000"
        def INGRESS_HOST = "ecoleta.org"

        stage('Checkout') {
            echo 'Iniciando Clone do Repositório'
            REPOS = checkout scm
            GIT_BRANCH = REPOS.GIT_BRANCH            
            if(GIT_BRANCH.equals("master")){
                KUBE_NAMESPACE = "prod"                
                ENVIRONMENT = "production"
            } else {
                if(GIT_BRANCH.equals("develop")){
                    KUBE_NAMESPACE = "staging"
                    ENVIRONMENT = "staging"
                    IMAGE_POSFIX = "-RC"
                    INGRESS_HOST = "staging.ecoleta.org"
                } else {
                    def error = "Não existe pipeline para a branch ${GIT_BRANCH}"
                    echo error
                    throw new Exception(error)
                }
            }
            HELM_DEPLOY_NAME = KUBE_NAMESPACE + "-frontend-ecoleta"
            IMAGE_VERSION = sh returnStdout: true, script: 'sh read-package-version.sh'
            IMAGE_VERSION = IMAGE_VERSION.trim() + IMAGE_POSFIX
        }
        stage('Package') {
            container('docker-container') {
                echo 'Iniciando Empacotamento com Docker'                
                sh "docker build -t ${REPO_DOCKER_LOCAL}/${IMAGE_NAME}:${IMAGE_VERSION} . --build-arg NPM_ENV='${ENVIRONMENT}'"
                sh "docker push ${REPO_DOCKER_LOCAL}/${IMAGE_NAME}:${IMAGE_VERSION}"                                
            }                                    
        }
        stage('Deploy') {
            container('helm-container') {
                echo 'Iniciando Deploy com Helm'                
                sh """
                    helm init --client-only
                    helm repo add ecoleta ${CHARTMUSEUM_URL}
                    helm repo update                    
                """
                try {
                    // Fazer helm upgrade
                    sh "helm upgrade --namespace=${KUBE_NAMESPACE} ${HELM_DEPLOY_NAME} ${HELM_CHART_NAME} --set image.tag=${IMAGE_VERSION} --set ingress.host[0]=${INGRESS_HOST}"
                } catch(Exception e){
                    // Fazer helm install
                    sh "helm install --namespace=${KUBE_NAMESPACE} --name ${HELM_DEPLOY_NAME} ${HELM_CHART_NAME} --set image.tag=${IMAGE_VERSION} --set ingress.host[0]=${INGRESS_HOST}"
                }
            }
        }   
    }//end of node
}